#ifndef GAME_H
#define GAME_H

#include "gaming-core/input/Buttons.h"
#include "gaming-core/math/Frustum.h"
#include "gaming-core/utils/Size.h"
#include "gaming-core/wrapper/Shader.h"
#include "gaming-core/wrapper/VertexBuffer.h"

class Game final {
    Shader& shader;
    Buttons& buttons;
    const Size& size;
    VertexBuffer vertexBuffer;
    Frustum frustum;

    Button& up;
    Button& down;
    Button& left;
    Button& right;
    Button& front;
    Button& back;
    Vector3 oldPosition;
    Vector3 position;

public:
    Game(Shader& shader, Buttons& buttons, const Size& size);

    void render(float lag);
    void tick();
};

#endif